#!/usr/local/bin/perl

#######################################################
#            Advanced Ranking System G2
#  
#
#  By installing and using Advanced Ranking System G2, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System G2.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: August 11, 1999
#      The script was last modified on: September 04,1999
#
#   Advanced Ranking System G2 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System G2 is licensed, not sold.
#
###################################################################

require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/\n/ /g;
$request{$name} = $value;
}
print "Content-type: text/html\n\n";
########################################################## tell the script what the action is
if ($request{'action'} eq "viewdata") {
&view_data;
exit;
}
if ($request{'action'} eq "pmodify") {
&preview_modify;
exit;
}
if ($request{'action'} eq "gethtml") {
&gethtml;
exit;
}
if ($request{'action'} eq "modify") {
&modify;
exit;
}
if ($request{'action'} eq "getid") {
&getid;
exit;
}
if ($request{'action'} eq "forgot_password") {
&forgot_password;
exit;
}
if ($request{'action'} eq "generate") {
&generate;
exit;
}
&header;
print <<EOF;

<h2>Account Managing System Main Page</h2>
<table><tr>
<td><form action="$member_cgi" method="post"><b>ID:</b></td>
<td><input type="text" name="id" size="5"></td></tr>
<tr><td><b>Password:</b></td><td><input type="password" name="password"></td></tr>
<tr><td valign="top"><b>Action:</b></td><td>
<input type="Radio" name="action" value="viewdata" checked>View State<br>
<input type="Radio" name="action" value="getid">Modify your account information<br>
<input type="Radio" name="action" value="gethtml">Get the html tags for putting on your web site<br>
<input type="Radio" name="action" value="forgot_password">Lost Password<br>
</td></tr>
<tr><td><input type="submit" value="GO!"></td>
</form></tr>
</table> 

EOF

&footer;

exit;

########################################################## view an entry

sub view_data {	
&vpassword;
open (total, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock total, 2; 
}
$total=<total>;
close(total);
if ($id > $total or !$id) {
&header;
print "<h2>Unable to locate the account</h2>\n";
print "Please make sure you have entered the correct ID number for your account.<br>\n";	
&footer;
exit;
} 
if (@data[10]==1) {
$state="Yes";
}
if (@data[10]==0) {
$state="No";
}	
@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(@data[9]))[0,1,2,3,4,5,6];
$sec = sprintf("%.02d",$sec);
$min = sprintf("%.02d",$min);
$hour = sprintf("%.02d",$hour);
$mday = sprintf("%.02d",$mday);
$year += 1900;
$date = "$days[$wday], $months[$mon] $mday, $year";
$time = "$hour:$min:$sec";
if (@data[3]==0) {
$ranking="N/A";
}
else {
$ranking=@data[3];
}		
&header;
print "<h2>Account State</h2>";
print "<table border=\"0\">";
print "<tr><td><b>ID:</b></td><td>$id</td></td>";
print "<tr><td><b>Title:</b></td><td>@data[4]</td></td>";
print "<tr><td><b>Url:</b></td><td>@data[5]</td></td>";
print "<tr><td><b>Description:</b></td><td>@data[6]</td></td>";
print "<tr><td><b>Contact Email:</b></td><td>@data[7]</td></td>";
print "<tr><td><b>Current ranking position:</b></td><td>$ranking</td></td>";
print "<tr><td><b>Total Vote(s)</b></td><td>@data[0]</td></td>";
print "<tr><td><b>Average Score</b></td><td>@data[2]</td></td>";
print "<tr><td><b>Total Score</b></td><td>@data[1]</td></td>";
print "<tr><td><b>Actived?</b></td><td>$state</td></td>";
print "<tr><td><b>Joined time:</b></td><td>$date at $time</td></td></table>";
print "<br><a href=\"$member_cgi\">Return</a> to the account managing system main page.<br>";   
&footer;
exit;
}
########################################################### preview before modify an entry
sub preview_modify {
&vpassword;
&header;
print "<h2>The following information will be changed:</h2>";
print "<table border=\"0\">\n";
print "<tr><td>Title:</td><td>$request{'name'}</td></tr>";
print "<tr><td>Url:</td><td>$request{'url'}</td></tr>";
print "<tr><td>Description:</td><td>$request{'description'}</td></tr>";
print "<tr><td>Contact Email:</td><td>$request{'email'}</td></tr>";
if ($request{'newpass'} or $request{'newpass2'}) { 
print "<tr><td>Your password.</td><td></td></tr>\n";
}
print "</table>\n";
print "<form action=\"$member_cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"name\" value=\"$request{'name'}\">\n";
print "<input type=\"hidden\" name=\"url\" value=\"$request{'url'}\">\n";
print "<input type=\"hidden\" name=\"description\" value=\"$request{'description'}\">\n";
if ($request{'newpass'} or $request{'newpass2'}) { 
print "<input type=\"hidden\" name=\"newpass\" value=\"$request{'newpass'}\">\n";
print "<input type=\"hidden\" name=\"newpass2\" value=\"$request{'newpass2'}\">\n";
}
print "<input type=\"hidden\" name=\"email\" value=\"$request{'email'}\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$request{'id'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"modify\">\n";
print "<input type=\"submit\" value=\"Modify!\"></form>";
&footer;
exit;
}

########################################################### modify

sub modify {
&vpassword;	
&ckfield;
open (data, ">$data_location/$id.dat") or &error("Unable to open the data file for writing");
if ($flock==1) {
flock data, 2; 
}
print data @data[0];
print data @data[1];
print data @data[2];
print data @data[3];
print data "$request{'name'}\n";
print data "$request{'url'}\n";
print data "$request{'description'}\n";
print data "$request{'email'}\n";
if ($password1) {
print data "$password1\n";	
}
else {	
print data @data[8];
}	
print data @data[9];
print data @data[10];
close(data);
&header;
print "<h2>Account information modified</h2>\n";
print "The following information had been changed:<br>\n";
print "<table border=\"0\">\n";
print "<tr><td>Title:</td><td>$request{'name'}</td></tr>";
print "<tr><td>Url:</td><td>$request{'url'}</td></tr>";
print "<tr><td>Description:</td><td>$request{'description'}</td></tr>";
print "<tr><td>Contact Email:</td><td>$request{'email'}</td></tr>";
if ($password1) {
print "<tr><td>Your password.</td><td></td></tr>\n";	
}
print "</table>\n";
print "<br><a href=\"$member_cgi\">Return</a> to the account managing system main page.<br>";
&footer;
exit;

}
################################################# get entry of an ID

sub getid {
&vpassword;
if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
&header;
print "<h2>Weird symbol</h2>\n";
print "Please don't use weird symbols\n";
&footer;
exit;
}
open (tid, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock tid, 2; 
}
$tid=<tid>;
close(tid);
if ($id > $tid or !$id) {
&header;
print "<h2>Unable to locate the account</h2>\n";
print "Please make sure you have entered the correct ID number for your account.<br>\n";
&footer;
exit;
} 
&header;
print "<table border=\"0\">";
print "<tr><td><form action=\"$member_cgi\" method=\"post\"><h2>Modify your account information</h2></td><td></td></tr>";
print "<tr><td>Title:</td><td><input type=\"text\" name=\"name\" value=\"@data[4]\"></td></tr>\n";
print "<tr><td>URL:</td><td><input type=\"text\" name=\"url\" value=\"@data[5]\"></td></tr>\n";
print "<tr><td>Description:</td><td><input type=\"text\" name=\"description\" value=\"@data[6]\"></td></tr>\n";
print "<tr><td>Contact Email:</td><td><input type=\"text\" name=\"email\" value=\"@data[7]\"></td></tr>\n";
print "<tr><td>New password(if you want to change your password):</b></td><td><input type=\"password\" name=\"newpass\" maxlength=\"16\"></td></tr>\n";
print "<tr><td>Confirm the new password:</td><td><input type=\"password\" name=\"newpass2\" maxlength=\"16\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"pmodify\"></td></tr>\n";	
print "<tr><td><input type=\"submit\" value=\"Modify!\"></form></td></tr>\n";
print "</table>";
&footer;
exit;
}

############################################Get html
sub gethtml {

&header;
print "<h2>Get the html tags</h2>\n";	
print "<b>Please copy and paste the following html tags onto your page. So your visitors will be able to vote.</b><br><br>\n";
print "&lt;center&gt;";
print "Rate this site at $topsite_name!<br>\n";
if ($gate_way==1) {
print "&lt;form action=\"$gateway_cgi\" method=\"POST\"&gt;<br>\n";
}
else {	
print "&lt;form action=\"$ranking_location\" method=\"POST\"&gt;<br>\n";
}
print "&lt;select name=\"score\"&gt;<br>";
print "&lt;option&gt;--<br>\n";
print "&lt;option value=\"10\"&gt;10- Best<br>\n";
print "&lt;option value=\"9\"&gt;9<br>\n";
print "&lt;option value=\"8\"&gt;8<br>\n";
print "&lt;option value=\"7\"&gt;7<br>\n";
print "&lt;option value=\"6\"&gt;6<br>\n";
print "&lt;option value=\"5\"&gt;5<br>\n";
print "&lt;option value=\"4\"&gt;4<br>\n";
print "&lt;option value=\"3\"&gt;3<br>\n";
print "&lt;option value=\"2\"&gt;2<br>\n";
print "&lt;option value=\"1\"&gt;1- Worst<br>\n";
print "&lt;/select&gt;<br>\n";
print "&lt;input type=\"hidden\" name=\"member\" value=\"$request{'id'}\"&gt;<br>\n";
print "&lt;input type=\"Submit\" value=\"Vote!\"&gt;<br>\n";
print "&lt;/form&gt;&lt;/center&gt;<br><br>\n";	
print "<b>You can also use a simple text link as the following:</b><br><br>\n";
print "&lt;a href=\"$gateway_cgi?member=$request{'id'}\"&gt;Rate this site at $topsite_name!&lt;/a&gt;<br><br>\n";
print "<br><a href=\"$member_cgi\">Return</a> to the account managing system main page.<br>";
&footer;	
exit;
}
	
############################################ forgot password
sub forgot_password {
&header;
print <<EOF;
<h2>Generate a new password</h2>
A new password will be sent to you via email, if we can locate your account.<br><br>
<table><tr><form action="$member_cgi" method="post">
<td><b>ID:</b></td>
<td>$request{'id'}</td></tr>
<tr><td><b>Email:</b></td><td><input type="text" name="email"><input type="hidden" name="id" value="$request{'id'}"><input type="hidden" name="action" value="generate"></td></tr>
<tr><td><input type="submit" value="Generate!"></td>
</form></tr>
</table>
EOF
&footer;
exit;	
}
		
############################################generate
sub generate {
$id=$request{'id'};
open (tid, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock tid, 2; 
}
$tid=<tid>;
close(tid);
if ($id > $tid or !$id) {
&header;
print "<h2>Unable to locate the account</h2>\n";
print "Please make sure you have entered the correct ID number for your account.<br>\n";
&footer;
exit;
} 
if ($id=~ tr/;<>*|`&$!#()[]{}:'"// or $request{'email'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
&header;
print "<h2>Weird symbol</h2>\n";
print "Please don't use weird symbols<br>\n";
&footer;
}
open (data, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);	
chomp(@data[7]);
$request{'email'}=~ tr/A-Z/a-z/;
@data[7]=~ tr/A-Z/a-z/;

if ($request{'email'} eq "@data[7]") {
$newpass = crypt($tid, "YL");
$newpass=~ tr/A-Z/a-z/;
$password= crypt($newpass, "MM");

open (MAIL, "|$mail_prog") or &error("Unable to open the mail program");
print MAIL "To: @data[7]\n";
print MAIL "From: $youremail\n";
print MAIL "Subject: $topsite_name- new password.\n";
print MAIL "Dear Sir or Madam,\n";
print MAIL "You have asked us to generate a new password for you,";
print MAIL "because you lost your old password.\n\n";
print MAIL "Your new password: $newpass\n\n";
print MAIL "You can modify your account information, change your password, view your account status,";
print MAIL "and get the html tags for inserting in your page by using the account managing system $member_cgi\n";
print MAIL "<$member_cgi>\n\n";
print MAIL "Yours sincerely,\n";
print MAIL "$topsite_name\n";
close(MAIL);

open (data, ">$data_location/$id.dat") or &error("Unable to open the data file for writing");
if ($flock==1) {
flock data, 2; 
}
print data @data[0];
print data @data[1];
print data @data[2];
print data @data[3];
print data @data[4];
print data @data[5];
print data @data[6];
print data @data[7];
print data "\n$password\n";	
print data @data[9];
print data @data[10];
close(data);
&header;
print "<h2>New password generated</h2>\n";
print "Your account has been located and a new password has been sent to you via email<br>";	
print "<br><a href=\"$member_cgi\">Return</a> to the account managing system main page.<br>";
&footer;
exit;
}
&header;
print "<h2>Unable to locate the account</h2>\n";
print "Sorry, we are unable to locate your account.<br>\n";
print "Please make sure you have entered the correct ID number and email address.<br>\n";
print "<br><a href=\"$member_cgi\">Return</a> to the main page of the member's section.<br>";
&footer;
exit;	
}

############################################ no action
sub exitnow {
&header;
print "<h2>Unable to locate the account</h2>\n";
print "Please make sure you have entered the correct ID number for your account.<br>\n";
&footer;
exit;
}
	
###### password

sub vpassword{
if (!$ENV{'REMOTE_HOST'}) {
$IP=$ENV{'REMOTE_ADDR'};
}
else {
$IP=$ENV{'REMOTE_HOST'};
}	
$id=$request{'id'};
if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
&header;       	
print "<h2>Weird symbol</h2>\n";
print "Please don't use weird symbols\n";
&footer;      
exit;
}
open (data, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);	

$request{'password'}=~ tr/A-Z/a-z/;
$pass2 = crypt($request{'password'}, "MM");
$pass=@data[8];
chomp($pass);
unless ($pass2 eq "$pass") {
$timenow=localtime();
&header;
print "<h2>Incorrect Password</h2> Sorry, the password you entered is incorrect.<br>";
print "<br>";
print "<ul>Your IP Address: $IP</ul>";
print "<ul>Password you entered: $request{'password'}</ul>";
print "<ul>Time: $timenow</ul>";
&footer;
exit;
}
}	
	
######################header input

sub header {
open (header, "<mheader.txt") or &error("Unable to open the header file");
if ($flock==1) {
flock header, 2; 
}
@header=<header>;
close(header);
print @header;
}

####################footer input

sub footer {
open (footer, "<mfooter.txt") or &error("Unable to open the footer file");
if ($flock==1) {
flock footer, 2; 
}
@footer=<footer>;
close(footer);
print @footer;
}	

####check fields
sub ckfield {
$e_count="0";
if (!$request{'name'}) {
$e_count++;
&cerror("The title of your web site is missing.<br>\n");
}
if (!$request{'description'}) {
$e_count++;
&cerror("The description of your web site is missing.<br>\n");
}
if (!$request{'email'}) {
$e_count++;
&cerror("Your email is missing.<br>\n");
}
unless ($request{'email'}=~/.*\@.*/)   { 
$e_count++;
&cerror("You have entered an invalid email address.<br>\n");
}
if (!$request{'url'}) {
$e_count++;
&cerror("The URL of your web site is missing<br>\n");
}
unless ($request{'url'}=~/http:/i)   { 
$e_count++;
&cerror("The URL that you have entered is invalid. It must start with http://<br>\n");
}
if ($request{'newpass'} or $input{'newpass2'}) {

$request{'newpass'}=~ tr/A-Z/a-z/; 
$password1 = crypt($request{'newpass'}, "MM");
$password2 = crypt($request{'newpass2'}, "MM");	
unless ($password1 eq "$password2") {
$e_count++;
&cerror("The two passwords that you have entered don't match.<br>\n");
}
}
sub cerror {
if ($e_count==1) {
&header;
print "<h2>Unable to modify the information</h2>\n";
}
print "$_[0]";
}
if ($e_count>0) {
&footer;
exit;
}
}
#####error
sub error {
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
	
}
	
	

