#!/usr/local/bin/perl

#######################################################
#            Advanced Ranking System G2
#  
#
#  By installing and using Advanced Ranking System G2, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System G2.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: August 11, 1999
#      The script was last modified on: September 28,1999
#
#   Advanced Ranking System G2 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System G2 is licensed, not sold.
#
###################################################################

require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $request{$name} = $value;
}
print "Content-type: text/html\n\n";

########################################################## tell the script what the action is

if ($request{'action'} eq "gethtml") {
&gethtml;
exit;
}
if ($request{'action'} eq "addmain") {
&addmain;
exit;
}
if ($request{'action'} eq "add") {
&add;
exit;
}
if ($request{'action'} eq "viewdata") {
&view_data;
exit;
}
if ($request{'action'} eq "view_all") {
&view_all;
exit;
}
if ($request{'action'} eq "pmodify") {
&preview_modify;
exit;
}
if ($request{'action'} eq "modify") {
&modify;
exit;
}
if ($request{'action'} eq "email") {
&email_main;
exit;
}
if ($request{'action'} eq "preview_email") {
&preview_email;
exit;
}
if ($request{'action'} eq "send_email") {
&send_email;
exit;
}
if ($request{'action'} eq "search") {
&search;
exit;
}
if ($request{'action'} eq "view_state") {
&view_state;
exit;
}
if ($request{'action'} eq "getid") {
&getid;
exit;
}
if ($request{'action'} eq "delete_main") {
&delete_main;
exit;
}
if ($request{'action'} eq "pdelete") {
&pdelete;
exit;
}
if ($request{'action'} eq "deletenow") {
&deletenow;
exit;
}
if ($request{'action'} eq "creset") {
&creset;
exit;
}
if ($request{'action'} eq "erase") {
&erase;
exit;
}
if ($request{'action'} eq "reset_all") {
&reset_all;
exit;
}
if ($request{'action'} eq "eraseall") {
&eraseall;
exit;
}
if ($request{'action'} eq "backup") {
&backup;
exit;
}
if ($request{'action'} eq "main_page") {
&main_page;
exit;
}

print <<EOF;
<HTML>
<HEAD>
<TITLE>Advanced Ranking System G2</TITLE>
</HEAD>
<BODY bgcolor="#ffffff">
<center>
<font face="Arial"><h1>Advanced Ranking System G2</h1>
Please enter your Admin Password to Login:
<form action="$cgi" method="post">
<input type="password" name="password">
<input type="hidden" name="action" value="main_page">
<input type="submit" value="ok">
</form>
</body>
</html>
EOF
exit;
############################################Get html
sub gethtml {

print "<h2>Get the html tags</h2>\n";	
print "<b>Please copy and paste the following html tags onto your page. So your visitors will be able to vote.</b><br><br>\n";
if ($gate_way==1) {
print "&lt;form action=\"$gateway_cgi\" method=\"POST\"&gt;<br>\n";
}
else {	
print "&lt;form action=\"$ranking_location\" method=\"POST\"&gt;<br>\n";
}
print "&lt;select name=\"score\"&gt;<br>";
print "&lt;option&gt;--<br>\n";
print "&lt;option value=\"10\"&gt;10- Best<br>\n";
print "&lt;option value=\"9\"&gt;9<br>\n";
print "&lt;option value=\"8\"&gt;8<br>\n";
print "&lt;option value=\"7\"&gt;7<br>\n";
print "&lt;option value=\"6\"&gt;6<br>\n";
print "&lt;option value=\"5\"&gt;5<br>\n";
print "&lt;option value=\"4\"&gt;4<br>\n";
print "&lt;option value=\"3\"&gt;3<br>\n";
print "&lt;option value=\"2\"&gt;2<br>\n";
print "&lt;option value=\"1\"&gt;1- Worst<br>\n";
print "&lt;/select&gt;<br>\n";
print "&lt;input type=\"hidden\" name=\"member\" value=\"$request{'id'}\"&gt;<br>\n";
print "&lt;input type=\"Submit\" value=\"Vote!\"&gt;<br>\n";
print "&lt;/form&gt;<br><br>\n";
print "<b>You can also use a simple text link as the following:</b><br><br>\n";
print "&lt;a href=\"$gateway_cgi?member=$request{'id'}\"&gt;Rate this site at $topsite_name!&lt;/a&gt;<br><br>\n";
print "<br><br><br>";
&button;	
exit;
}

########################################################## add main
sub addmain {

print <<EOF;
<html>
<head>
<title>Advanced Ranking System G2</title>
</head>
<body bgcolor="#ffffff">
<center><font face="Arial">
<b><font size="+3">Advanced Ranking System G2</font></b><font size="-1">&nbsp;&nbsp;<a href="http://www.cgi-factory.com">CGI-Factory.com</a></font>
<br><br>
<h2>Add an new entry</h2><table border="0">
<tr><td><b>Title:</b></td><td><form action="rank-admin.pl" method="POST">
<input type="Text" name="name"></td></tr>
<tr><td><b>SITE URL:</b></td><td><input type="Text" name="url" value="Http://"></td></tr>
<tr><td><b>Description:</b></td><td><input type="Text" name="description"></td></tr>
<tr><td><b>Email:</b></td><td><input type="Text" name="email"></td></tr>
<tr><td><b>Password:</b></td><td><input type="Text" name="password1"></td></tr>
<tr><td><b>Confirm the password:</b></td><td><input type="Text" name="password2"><input type="hidden" name="password" value="$request{'password'}"></td></tr>
<tr><td><b>Active this account?</b></td><td><input type="radio" name="act" value="1" checked>Yes <input type="radio" name="act" value="2">No</td></tr>
<tr><td><input type="hidden" name="action" value="add"><input type="Submit" value="ok"></form></td><td></td></tr>
</table>
</BODY>
</HTML>	
EOF
exit;
}	
########################################################## add
sub add {
&vpassword;
&ckfield;
open (count, "<count.txt")  or &error("Unable to open the counting file");
if ($flock==1) {
flock count, 2; 
}
$count=<count>;
close (count);
$count++;
open (wcount, ">count.txt")  or &error("Unable to write to the counting file");
if ($flock==1) {
flock wcount, 2; 
}

print wcount "$count";
close (wcount);
$time=time();
open (members, ">$data_location/$count.dat") or &error("Unable to create the data file");
if ($flock==1) {
flock members, 2; 
}

print members "0\n";
print members "0\n";
print members "0\n";
print members "0\n";
print members "$request{'name'}\n";
print members "$request{'url'}\n";
print members "$request{'description'}\n";
print members "$request{'email'}\n";
print members "$password1\n";
print members "$time\n";
if ($request{'act'}==1) {
print members "1\n";
}
else {
print members "0\n";
}
close(members);

print "<h2>New entry was added successfully.</h2>\n";
print "Please copy and paste the following html tags onto your page. So your visitors will be able to vote.<br><br>\n";
if ($gate_way==1) {
print "&lt;form action=\"$gateway_cgi\" method=\"POST\"&gt;<br>\n";
}
else {
print "&lt;form action=\"$ranking_location\" method=\"POST\"&gt;<br>\n";
}
print "&lt;select name=\"score\"&gt;<br>";
print "&lt;option&gt;--<br>\n";
print "&lt;option value=\"10\"&gt;10- Best<br>\n";
print "&lt;option value=\"9\"&gt;9<br>\n";
print "&lt;option value=\"8\"&gt;8<br>\n";
print "&lt;option value=\"7\"&gt;7<br>\n";
print "&lt;option value=\"6\"&gt;6<br>\n";
print "&lt;option value=\"5\"&gt;5<br>\n";
print "&lt;option value=\"4\"&gt;4<br>\n";
print "&lt;option value=\"3\"&gt;3<br>\n";
print "&lt;option value=\"2\"&gt;2<br>\n";
print "&lt;option value=\"1\"&gt;1- Worst<br>\n";
print "&lt;/select&gt;<br>\n";
print "&lt;input type=\"hidden\" name=\"member\" value=\"$count\"&gt;<br>\n";
print "&lt;input type=\"Submit\" value=\"Vote!\"&gt;<br>\n";
print "&lt;/form&gt;<br><br>\n";
print "<b>You can also use a simple text link as the following:</b><br><br>\n";
print "&lt;a href=\"$gateway_cgi?member=$count\"&gt;Rate this site at $topsite_name!&lt;/a&gt;<br><br>\n";
print "Once you have pasted the tags on your page. Please click on the vote button to active this entry.<br><br>\n";
print "<br><br><br>";
&button;
exit;
}

####check fields
sub ckfield {
$e_count="0";
if (!$request{'name'}) {
$e_count++;
&cerror("The title of your web site is missing.<br>\n");
}
if (!$request{'description'}) {
$e_count++;
&cerror("The description of your web site is missing.<br>\n");
}
if (!$request{'email'}) {
$e_count++;
&cerror("Your email is missing.<br>\n");
}
unless ($request{'email'}=~/.*\@.*/)   { 
$e_count++;
&cerror("You have entered an invalid email address.<br>\n");
}
if (!$request{'url'}) {
$e_count++;
&cerror("The URL of your web site is missing<br>\n");
}
unless ($request{'url'}=~/http:/i)   { 
$e_count++;
&cerror("The URL that you have entered is invalid. It must start with http://<br>\n");
}
if (!$request{'password1'} or !$request{'password2'}) {
$e_count++;
&cerror("One or both password fields are missing.<br>\n");
}
else {
$request{'password1'}=~ tr/A-Z/a-z/; 
$password1 = crypt($request{'password1'}, "MM");
$password2 = crypt($request{'password2'}, "MM");	
unless ($password1 eq "$password2") {
$e_count++;
&cerror("The two passwords you have entered don't match.<br>\n");
}
}
sub cerror {
if ($e_count==1) {

print "<h2>Unable to create the account</h2>\n";
}
print "$_[0]";
}
if ($e_count>0) {

exit;
}
}
########################################################## view an entry

sub view_data {	

&vpassword;

$id= $request{'id'};

if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}


open (total, "<count.txt") or &error("Unable to open the count file");

if ($flock==1) {

flock total, 2; 

}

$total=<total>;

close(total);

$id= $request{'id'};

if ($id > $total or !$id) {
print "<h2>Unable to locate the member</h2>\n";
print "Member's data file was not found in the database.";
print "<br><br><br>";
&button;	
exit;
} 
open (data, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);
if (@data[10]==1) {
$state="Yes";
}
if (@data[10]==0) {
$state="No";
}	
@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(@data[9]))[0,1,2,3,4,5,6];
$sec = sprintf("%.02d",$sec);
$min = sprintf("%.02d",$min);
$hour = sprintf("%.02d",$hour);
$mday = sprintf("%.02d",$mday);
$year += 1900;$date = "$days[$wday], $months[$mon] $mday, $year";
$time = "$hour:$min:$sec";
if (@data[3]==0) {
$ranking="N/A";
}
else {
$ranking=@data[3];
}
print "<h2>View a member's data file</h2>\n";
print "<b>ID:</b>$id<br>";
print "<b>Title:</b>&nbsp;@data[4]<br>";
print "<b>Url:</b>&nbsp;@data[5]<br>";
print "<b>Description:</b>&nbsp;@data[6]<br>";
print "<b>Contact Email:</b>&nbsp;@data[7]<br>";
print "<b>Current ranking position:</b>&nbsp;$ranking<br>";
print "<b>Total Vote(s)</b>&nbsp;@data[0]<br>";
print "<b>Average Score</b>&nbsp;@data[2]<br>";
print "<b>Total Score</b>&nbsp;@data[1]<br>";
print "<b>Actived?</b>&nbsp;$state<br>";
print "<b>Joined time:</b>&nbsp;$date at $time<br>";
print "<br><br><br>";
&button;
exit;
}
########################################################## view all entries

sub view_all {
&vpassword;

open (tid, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock tid, 2; 
}
$tid=<tid>;
close(tid);

$tid++;
$found=0;
$i=1;
if ($request{'next'}) {
if ($request{'next'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}
$i=$request{'next'};
$i++;
}
if ($request{'start'}) {
if ($request{'next'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}
$i=$request{'start'};
}
print "<h2>View $request{'view_option'} Members</h2>\n";
READ: for ($i; $i<$tid; $i++) {
open ($i, "<$data_location/$i.dat") or next READ;
if ($flock==1) {
flock $i, 2; 
}
@$idata=<$i>;
close($i);
if ($request{'view_option'} eq "actived") {
if (@$idata[10]==0) { next READ }
}
if ($request{'view_option'} eq "inactived") {
if (@$idata[10]==1) { next READ }
}
$found++;
	
print "<table border=\"0\">";
print "<tr><td>Title: @$idata[4] ID:$i&nbsp;</td>\n";
print "<td><form action=\"$cgi\" method=\"post\"><input type=\"hidden\" name=\"id\" value=\"$i\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"getid\">\n";
print "<input type=\"submit\" value=\"Modify\"></form></td>\n";
print "<td><form action=\"$cgi\" method=\"post\">\n";
print "&nbsp;<input type=\"hidden\" name=\"id\" value=\"$i\"><input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">";
print "<input type=\"hidden\" name=\"action\" value=\"viewdata\">";
print "<input type=\"submit\" value=\"View data\"></form></td></tr>";
print "</table>\n\n";

if ($found==20) {
$check=$tid-$i;
unless ($check == 1) {
print "<form action=\"$cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"view_option\" value=\"$request{'view_option'}\">\n";
print "<input type=\"hidden\" name=\"next\" value=\"$i\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"view_all\">\n";
print "<input type=\"Submit\" value=\"next page\">\n";
print "</form>\n";
print "<br><br><br>";
&button;		
exit;
}	
}	
}
if ($found==0) {
print "No matches were found<br>\n";
print "<br><br><br>";
&button;
}
else {	
print "End of search results<br>\n";
print "<br><br><br>";
&button;
}
exit;
}

########################################################### preview before modify an entry

sub preview_modify {

&vpassword;

if ($request{'act'}==1) {
$status="Active this acount";	
}
if ($request{'act'}==0) {
$status="Deactive this acount";	
}	
print "The following information will be changed:<br>";
print "Title: $request{'name'}<br>";
print "Url: $request{'url'}<br>";
print "Description: $request{'description'}<br>";
print "Contact Email: $request{'email'}<br>";
print "$status";
print "<form action=\"$cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"name\" value=\"$request{'name'}\">\n";
print "<input type=\"hidden\" name=\"url\" value=\"$request{'url'}\">\n";
print "<input type=\"hidden\" name=\"description\" value=\"$request{'description'}\">\n";
print "<input type=\"hidden\" name=\"email\" value=\"$request{'email'}\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$request{'id'}\">\n";
print "<input type=\"hidden\" name=\"act\" value=\"$request{'act'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"modify\">\n";
print "<input type=\"submit\" value=\"Modify!\"></form>";
print "<br><br><br>";
&button;
exit;
}

########################################################### modify

sub modify {

&vpassword;	
$id=$request{'id'};
if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}

open (rdata, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock rdata, 2; 
}
@member=<rdata>;
close(rdata);

open (data, ">$data_location/$id.dat") or &error("Unable to open the data file for writing");
if ($flock==1) {
flock data, 2; 
}
print data @member[0];
print data @member[1];
print data @member[2];
print data @member[3];
print data "$request{'name'}\n";
print data "$request{'url'}\n";
print data "$request{'description'}\n";
print data "$request{'email'}\n";
print data @member[8];
print data @member[9];
print data "$request{'act'}\n";
close(data);
if ($request{'act'}==0) {
$status="This account is deactived.";
}
if ($request{'act'}==1) {
$status="This account is actived.";
}	
print "<h2>The following information were updated</h2>\n";
print "Title: $request{'name'}<br>\n";
print "Url: $request{'url'}<br>\n";
print "Description: $request{'description'}<br>\n";
print "Contact Email: $request{'email'}<br>\n";
print "$status\n";
print "<br><br><br>\n";
&button;
exit;
}

########################################################### comfirm reseting all datas
sub reset_all {

&vpassword;	
print "<h2>Reset all members' data records</h2>\n";
print "Are you sure you want to do this? All members' data records will be set to zero<br>\n";
print "<form action=\"$cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"eraseall\">";
print "<input type=\"submit\" value=\"ok\"></form>\n"; 
print "<br><br><br>\n";
&button;
exit;
}
########################################################### reset all datas
sub eraseall {

&vpassword;	
opendir (DIR, "$data_location") or &error("Unable to open the dir for reading");
@reading=readdir(DIR);
@members=grep(/\.dat/, @reading);
close (DIR);
Opening:foreach $member (@members) {
open (bdata, "<$data_location/$member") or &error("Unable to open the member's data for reading");
if ($flock==1) {
flock bdata, 2; 
}
@bdata=<bdata>;
close(bdata);
if (@bdata[10]==0) {
next Opening;	
}

@reset=("0\n","0\n","0\n","0\n");

splice(@bdata, 0,4, @reset);
open (bdata2, ">$data_location/$member") or &error("Unable to open the member's data for writing");
if ($flock==1) {
flock bdata2, 2; 
}
print bdata2 @bdata;
close(bdata2);
}
print "<h2>Done</h2>\n";
print "<br><br><br>";
&button;
exit;
}

########################################################### comfirm reseting data
sub creset {

&vpassword;	
$id=$request{'id'};
if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
        	
}
open (bdata, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock bdata, 2; 
}
close(bdata);

print "<h2>Reset a member's data record</h2>\n";
print "Are you sure you want to do this?<br>The voting record for ID.$id will be reset to zero<br>\n";
print "<form action=\"$cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"erase\">";
print "<input type=\"submit\" value=\"ok\"></form>\n"; 
print "<br><br><br>";
&button;
exit;

}
	
	
########################################################### reset data
sub erase {

&vpassword;	
$id=$request{'id'};

if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}

open (bdata, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock bdata, 2; 
}
@bdata=<bdata>;
close(bdata);
@reset=("0\n","0\n","0\n","0\n");
splice(@bdata, 0,4, @reset);
open (bdata2, ">$data_location/$id.dat") or &error("Unable to write to the member's data file");
if ($flock==1) {
flock bdata2, 2; 
}
print bdata2 @bdata;
close(bdata2);
print "<h2>Done</h2>\n";
print "<br><br><br>";
&button;
exit;
}

################################################# get entry of an ID

sub getid {

&vpassword;
$id= $request{'id'};
if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}

open (tid, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock tid, 2; 
}
$tid=<tid>;
close(tid);

$id= $request{'id'};

if ($id > $tid or !$id) {
print "<h2>member's data file was not found in database</h2>";
exit;
} 

open (data, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);
	
print "<table>";
print "<form action=\"$cgi\" method=\"post\"><table border=\"0\">\n";
print "<tr><td><b>Modify a member's data file</b></td><td></td></tr>";
print "<tr><td>Title </td><td><input type=\"text\" name=\"name\" value=\"@data[4]\"></td></tr>\n";
print "<tr><td>URL </td><td><input type=\"text\" name=\"url\" value=\"@data[5]\"></td></tr>\n";
print "<tr><td>Description </td><td><input type=\"text\" name=\"description\" value=\"@data[6]\"></td></tr>\n";
print "<tr><td>Contact Email </td><td><input type=\"text\" name=\"email\" value=\"@data[7]\"></td></tr>\n";
print "<tr><td><b>Active this account?</b></td><td><input type=\"radio\" name=\"act\" value=\"1\" checked>Yes <input type=\"radio\" name=\"act\" value=\"0\">No</td></tr>";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"pmodify\">\n";	
print "<tr><td><input type=\"submit\" value=\"Modify!\"></form></td></tr>\n";
print "</table>";
print "<br><br><br>";
&button;	
exit;

}
################################################# delete main

sub delete_main {

print <<EOF;

<html>
<head>
<title>Advanced Ranking System G2</title>
</head>
<body bgcolor="#ffffff">
<center><font face="Arial">
<b><font size="+3">Advanced Ranking System G2</font></b><font size="-1">&nbsp;&nbsp;<a href="http://www.cgi-factory.com">CGI-Factory.com</a></font>
<br><br>
<b><h2>Delete a member from the database</h2></b><br><br>
<table border="0">
<form action="$cgi" method="post">
<tr><td><b>Member's ID</b></td><td><input type="Text" name="id"></td></tr>
<tr><td></td><td><input type="Checkbox" name="notify" value="yes" checked>Send the following mail to the member whose account is going to be terminated.</td></tr>
<tr><td><b>Subject:</b></td><td><input type="text" name="subject" size="60" value="Your account has been ternimated- $topsite_name"></td></tr>
<tr><td valign="top"><b>Message:</b></td><td><br>
<textarea cols="70" rows="15" name="message">
Dear Sir or Madam,
Your account has been terminated for some reasons. If you have any question, please contact us at $youremail.


Yours sincerely,
$topsite_name
</textarea></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td></tr>
<tr><td></td><td><input type="hidden" name="action" value="pdelete">
<input type="submit" value="ok">
</form></td></tr></table></font></center>
</body>
</html>

EOF

exit;
}
################################################# delete a member
sub pdelete {

&vpassword;

$id= $request{'id'};

if ($id=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}

open (tid, "<count.txt") or &error("Unable to open the count file");
if ($flock==1) {
flock tid, 2; 
}
$tid=<tid>;
close(tid);
$id= $request{'id'};
if ($id > $tid or !$id) {
print "<h2>Unable to locate the member</h2>\n";
print "Member's data file was not found in the database.";	
exit;
} 

open (data, "<$data_location/$id.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;	
close(data);
	
$request{'subject'}=~ s/"/&quot;/ig;
$request{'message'}=~ s/"/&quot;/ig;
$request{'subject'}=~ s/</&lt;/g;
$request{'subject'}=~ s/>/&gt;/g;
$request{'message'}=~ s/</&lt;/g;
$request{'message'}=~ s/>/&gt;/g;
$request{'message'}=~ s/\n/<br>/g;

print "<b>The following member will be deleted from the database.</b><br>\n";
print "<form action=\"$cgi\" method=\"post\">\n";
print "<b>Title:</b> @data[4]<br>\n";
print "<b>URL:</b> @data[5]<br>\n";
print "<b>Description:</b> @data[6]<br>\n";
print "<b>Contact Email:</b> @data[7]<br><br>\n";
if ($request{'notify'} eq "yes") { 
print "<b>The following mail will be sent to the member:</b><br><br>\n";
print "<b>Subject:</b> $request{'subject'}<br>\n";
print "<b>Message:</b><br>$request{'message'}<br>\n";
$request{'message'}=~ s/<br>/\n/g;
print "<input type=\"hidden\" name=\"subject\" value=\"$request{'subject'}\">\n";
print "<input type=\"hidden\" name=\"message\" value=\"$request{'message'}\">\n";
print "<input type=\"hidden\" name=\"notify\" value=\"yes\">";
}
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"deletenow\">\n";	
print "<input type=\"submit\" value=\"delete\">\n";
print "</form>\n";
print "<br><br><br>";
&button;
exit;
}

############################################ deletenow

sub deletenow {
	
&vpassword;
	
if ($request{'id'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
        	
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}

$request{'subject'}=~ s/&quot;/"/ig;
$request{'message'}=~ s/&quot;/"/ig;
$request{'subject'}=~ s/&lt;/</g;
$request{'subject'}=~ s/&gt;/>/g;
$request{'message'}=~ s/&lt;/</g;
$request{'message'}=~ s/&gt;/>/g;	
open (data, "<$data_location/$request{'id'}.dat") or &exitnow;
if ($flock==1) {
flock data, 2; 
}

@data=<data>;
close(data);

if ($request{'notify'} eq "yes") {
open (MAIL, "|$mail_prog") or &error("Can't open the mail program!");
print MAIL "To: @data[7]";
print MAIL "From: $youremail\n";
print MAIL "Subject: $request{'subject'}\n\n";
print MAIL "$request{'message'}\n\n";
close (MAIL);
}
	
unlink("$data_location/$request{'id'}.dat");
print "<h2>Member Deleted</h2>\n";
print "@data[4]'s data file has been deleted. (ID: $request{'id'})<br>\n";
print "<br><br><br>";
&button;
	
exit;

}

########################################### backup data

sub backup {

&vpassword;

opendir (DIR, "$data_location") or &error("Unable to open the dir for reading");

if ($flock==1) {
flock DIR, 2; 
}
@reading=readdir(DIR);
@members=grep(/\.dat/, @reading);
close (DIR);

Opening:foreach $member (@members) {
	
open (bdata, "<$data_location/$member") or &error("Unable to open the member's data for reading");
if ($flock==1) {
flock bdata, 2; 
}
@bdata=<bdata>;
close(bdata);
open (bdata2, ">$backup_location/$member.bk") or &error("Unable to create the back up files");
if ($flock==1) {
flock bdata2, 2; 
}
print bdata2 @bdata;
close(bdata2);
}
open (bktime, ">bktime.txt") or &error("Unable to create the file for recording the last backup time");
if ($flock==1) {
flock bktime, 2; 
}
print bktime time();
close(bktime);
print "<h2>Done.</h2>\n";
print "<br><br><br>";
&button;
exit;
}

############################################ view state

sub view_state {
&vpassword;
opendir (DIR, "$data_location") or &error("Unable to open the dir for reading");
if ($flock==1) {
flock DIR, 2; 
}
@reading=readdir(DIR);	
@members=grep(/\.dat/, @reading);
close (DIR);

$dirsize= @dirsize[7];
$total=0;
$actived=0;
$inactived=0;
$hitin=0;

OPENING:foreach $member (@members) {

open (data, "<$data_location/$member") or next OPENING;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);
if (@data[10]==0) {
$inactived++;
}	
if (@data[10]==1) {
$actived++;
}
$total++;
$hitin=$hitin+@data[0];
}
open (ptime, "<time.txt") or &error("Unable to open the file- time.txt");
if ($flock==1) {
flock ptime, 2; 
}
$ptime=<ptime>;
close(ptime);
if ($ptime) {
@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime($ptime))[0,1,2,3,4,5,6];
$sec = sprintf("%.02d",$sec);
$min = sprintf("%.02d",$min);
$hour = sprintf("%.02d",$hour);
$mday = sprintf("%.02d",$mday);
$year += 1900;$time = "On $days[$wday], $months[$mon] $mday, $year at $hour:$min:$sec";
}
else {
$time="N/A";
}
print "<h2>Ranking System State</h2>\n";
print "<b>Total members:</b> $total\n<br>";
print "<b>Actived members:</b> $actived\n<br>";
print "<b>Inactived members:</b> $inactived\n<br>";
print "<b>Total number of votes:</b> $hitin\n<br>";
print "<b>The ranking list was updated:</b> $time\n<br><br>";
print "<b>Click the button below, if you want to update or create the ranking list right now.</b> <form action=\"update.pl\" method=\"post\"><input type=\"submit\" value=\"Update/Create ranking list\"></form>";
print "<br><br><br>";
&button;
exit;
}

############################################ no action
sub exitnow {
print "<h2>Unable to locate the member</h2>\n";
print "Member's data file was not found in the database.";	
print "<br><br><br>";
&button;
exit;
	
}
	
###### password

sub vpassword{
if (!$ENV{'REMOTE_HOST'}) {
$IP=$ENV{'REMOTE_ADDR'};
}
else {
$IP=$ENV{'REMOTE_HOST'};
}	
open (PASS,"pass.dat") or &error("Unable to open the password file"); 
if ($flock==1) {
flock PASS, 2; 
}
$pass = <PASS>;
close(PASS);
$request{'password'}=~ tr/A-Z/a-z/;
$pass2 = crypt($request{'password'}, "MM");
unless ($pass eq "$pass2") {
$timenow=localtime();
print "<h2>Incorrect login</h2>";
print "The password you entered is incorrect.<br>";
print "The following information has been sent to the webmaster of the web site for security reasons.<br>";
print "<ul>Your IP Address:$IP</ul>";
print "<ul>Password your entered: $request{'password'}</ul>";
print "<ul>Time: $timenow</ul>";
print "</body></html>";
 
if ($alert==1) {       
open (MAIL, "|$mail_prog") or &error("Unable to open the mail program");
print MAIL "To: $youremail\n";
print MAIL "From: $youremail\n";
print MAIL "Subject: bad password\n";
print MAIL "someone entered the wrong password for entering the admin script.\n";
print MAIL "Here is information:\n\n";
print MAIL "IP Address: $IP\n";
print MAIL "Password: $request{'password'}\n";
print MAIL "$timenow\n";
close(MAIL);
exit;
}      
exit;
}
}	
	
sub main_page {
&vpassword;		
open (bktime, "<bktime.txt") or $backup="NA";
if ($flock==1) {
flock bktime, 2; 
}
$bktime=<bktime>;
close(bktime);
if ($bktime) {
@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
@days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime($bktime))[0,1,2,3,4,5,6];
$sec = sprintf("%.02d",$sec);
$min = sprintf("%.02d",$min);
$hour = sprintf("%.02d",$hour);
$mday = sprintf("%.02d",$mday);
$year += 1900;$date = "$days[$wday], $months[$mon] $mday, $year";
$time = "$hour:$min:$sec";
$backup="$date at $time";
}
if (!$backup) {
$backup="N/A";
}

print <<EOF;
<HTML>
<HEAD>
<TITLE>Advanced Ranking System G2</TITLE>
</HEAD>
<BODY bgcolor="#ffffff">
<center>
<font face="Arial"><h1>Advanced Ranking System G2</h1>&nbsp;&nbsp;<a href="http://www.cgi-factory.com/">CGI-Factory.com</a></font>
<br><br>
<table border="1">
<tr>
<td valigin="top">
<table border="0">
<tr><td><b>Modify the Ranking System Configuration</b></td></tr>
<tr><td><form action="configur.pl" method="post">
<input type="hidden" name="password" value="$request{'password'}">
<input type="hidden" name="action" value="main_page">
</td></tr>
<tr><td>
<input type="submit" value="Modify">
</form>
<br>
Warning! Incorrect settings may cause the ranking system to stop working. 
</td></tr></table>
<br>
<table>
<tr><td><b>View all members' data files</b></td></tr>
<form action="$cgi" method="post">
<tr><td><b>Start at:<input type="text" name="start" value="1"> (ID)</b></td></tr>
<tr><td>
<input type="hidden" name="password" value="$request{'password'}">
<select name="view_option">
<option value="all">all members
<option value="actived">actived members
<option value="inactived">inactived members
</select>
</td></tr>
<tr><td><input type="hidden" name="action" value="view_all">
<input type="submit" value="ok">
</form>
</td></tr></table>
<b>View a member's data file:</b><br>
<table><tr><form action="$cgi" method="post">
<td><b>ID:</b></td>
<td><input type="text" name="id"></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="viewdata"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr>
</table>
<b>Reset a member's voting record to zero:</b><br>
<table><tr><form action="$cgi" method="post">
<td><b>ID:</b></td>
<td><input type="text" name="id"></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="creset"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr></table>
<b>Get the HTML tags for inserting in your page:</b><br>
<table><tr><form action="$cgi" method="post">
<td><b>ID:</b></td>
<td><input type="text" name="id"></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="gethtml"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr>
</table>
</td>
<td valign="top">
<table>
<tr><td><b>Add a new member:</b></td></tr>
<tr><td><form action="$cgi" method="post">
<input type="hidden" name="password" value="$request{'password'}"></td></tr>
<tr><td><input type="hidden" name="action" value="addmain">
<input type="submit" value="ok">
</form>
</td></tr></table>
<table>
<tr><td><b>Reset all members' voting records to zero:</b></td></tr>
<tr><td><form action="$cgi" method="post">
<input type="hidden" name="password" value="$request{'password'}"></td></tr>
<tr><td><input type="hidden" name="action" value="reset_all">
<input type="submit" value="ok">
</form>
</td></tr></table>
<b>Send emails to members:</b><br>
<table><tr><form action="$cgi" method="post">
<td></td>
<td></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="email"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr>
</table>
<br>
<b>Database State</b><br>
<table><tr><form action="$cgi" method="post">
<td></td>
<td></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="view_state"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr></table>
<br>
<b>Delete members</b><br>
<table><tr><form action="$cgi" method="post">
<td></td>
<td></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="delete_main"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr></table>
<br>
<b>Back up the Data Files</b><br>
<table><tr><form action="$cgi" method="post">
<td>Last database backup: $backup</td>
<td></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="backup"></tr>
<tr><td><input type="submit" value="ok"></td>
</form></tr></table>
</td></tr>
</table>
<hr width="600">
<table>
<tr>
<td valign="top">
<table>
<tr><td><b>Modify a member's data file:</b></td></tr>
<tr><form action="$cgi" method="post">
<td><b>ID:<input type="text" name="id"></b></td>
</tr>
<tr><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="getid"></tr>
<tr><td><input type="submit" value="ok"></form></td>
</tr></table>
</td>
<td valign="top">
<table>
<tr><td><b>Keyword Search:</b></td></tr>
<tr><form action="$cgi" method="post">
<td><b>Keyword:</b><input type="text" name="keyword"></td>
</tr>
<tr><td><input type="hidden" name="password" value="$request{'password'}"></td>
<input type="hidden" name="action" value="search"></tr>
<tr><td>Keyword Match: All<input type="Radio" name="match" value="all" checked> Any<input type="Radio" name="match" value="any"> Exact phrase<input type="Radio" name="match" value="exact"></td></tr>
<tr><td>All members<input type="Radio" name="actived" value="3" checked> Actived members<input type="Radio" name="actived" value="1"> Inactived members<input type="Radio" name="actived" value="0"></td>
</tr>
<tr><td><input type="submit" value="ok"></form></td>
</tr></table>
</td>
</tr>
</table>
<br>
<font size="+1"><b>Warning: Please close your browser if you want to log off.</b></font>
<br>
<hr width="600"><font size="-1">Copyright 1999 CGI-Factory.com</font></font>
</center>
</BODY>
</HTML>

EOF
exit;
}
#### Email Main page.
sub email_main {
print <<EOF;
<html>
<head>
<title>Advanced Ranking System G2</title>
</head>
<body bgcolor="#ffffff">
<center><font face="Arial">
<b><font size="+3">Advanced Ranking System G2</font></b><font size="-1">&nbsp;&nbsp;<a href="http://www.cgi-factory.com">CGI-Factory.com</a></font>
<br><br>
<table border="0">
<form action="$cgi" method="post">
<tr><td><b>To</b> <select name="to">
<option value="all">All</option>
<option value="actived">Actived</option>
<option value="inactived">Inactived</option></select></td>
<td><b>members</b>
</td></tr>
<tr><td><b>Subject:</b></td><td><input type="text" name="subject" size="60"></td></tr>
<tr><td valign="top"><b>Message:</b></td><td><br><textarea cols="70" rows="15" name="message"></textarea></td></tr>
<tr><td></td><td><input type="hidden" name="password" value="$request{'password'}"></td></tr>
<tr><td></td><td><input type="hidden" name="action" value="preview_email">
<input type="submit" value="Send">
</form></td></tr></table></font></center>
</body>
</html>
EOF
exit;
}

#####preview mail

sub preview_email {
	
&vpassword;
$request{'subject'}=~ s/"/&quot;/ig;
$request{'message'}=~ s/"/&quot;/ig;
$request{'subject'}=~ s/</&lt;/g;
$request{'subject'}=~ s/>/&gt;/g;
$request{'message'}=~ s/</&lt;/g;
$request{'message'}=~ s/>/&gt;/g;
$request{'message'}=~ s/\n/<br>/g;


print "<html>\n";
print "<head>\n";
print "<title>\n";
print "Advanced Ranking System G2\n";
print "</title>\n";
print "</head>\n";
print "<body bgcolor=\"#ffffff\">\n";
print "The following information will be sent:<br>\n";
print "To $request{'to'} members<br>\n";
print "Subject: $request{'subject'}<br>\n";
print "Message: $request{'message'}<br>\n";
$request{'message'}=~ s/<br>/\n/g;
print "<form action=\"$cgi\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"subject\" value=\"$request{'subject'}\">\n";
print "<input type=\"hidden\" name=\"message\" value=\"$request{'message'}\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\"><br>\n";
print "<input type=\"hidden\" name=\"to\" value=\"$request{'to'}\"><br>\n";
print "<input type=\"hidden\" name=\"action\" value=\"send_email\">\n";
print "<input type=\"submit\" value=\"ok\">\n";
print "</form>\n";
print "</body>\n";
print "</html>\n";
print "<br><br><br>";
&button;
exit;
}

###### Keyword search
sub search {
if (!$request{'keyword'}) {
print "No keywords were entered.<br>\n";
print "<br><br><br>";
&button;
exit;
}
&vpassword;
$find=0;
############################################################Keywords handling
if ($request{'match'} eq "any") {
@keyword = split(/\s/, $request{'keyword'});
@keyword=join ("|", @keyword);
}
elsif ($request{'match'} eq "all") {
@keyword= split(/\s/, $request{'keyword'});
@keyword=join (".*", @keyword);
}
elsif ($request{'match'} eq "exact") {
@keyword =$request{'keyword'};
}
####3
opendir (DIR, "$data_location") or &error("Unable to open the dir for reading");
if ($flock==1) {
flock DIR, 2; 
}
@reading=readdir(DIR);
@members=grep(/\.dat/, @reading);
close (DIR);
print "<h1>Search Results</h1>\n";
Now:foreach $member (@members) {
open (memberx, "<$data_location/$member") or next Now;
if ($flock==1) {
flock memberx, 2; 
}
@memberx=<memberx>;
close(memberx);
chomp(@memberx[4]);
chomp(@memberx[5]);
chomp(@memberx[6]);
chomp(@memberx[7]);
chomp(@memberx[10]);
$state=@memberx[10];
if ($request{'actived'}==0) {
unless ($state==0) {
next Now;
}	
}
if ($request{'actived'}==1) {
unless ($state==1) {
next Now;
}	
}
unless (@memberx[4]=~ /@keyword/i or @memberx[6]=~ /@keyword/i) {
next Now;
}
$find++;
$member =~ s/\.dat//;
print "<table border=\"0\">
<tr><td><b>$find.</b> <a href=\"@memberx[5]\">@memberx[4]</a><br>\n
<td><form action=\"$cgi\" method=\"post\"><input type=\"hidden\" name=\"id\" value=\"$member\">\n
<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n
<input type=\"hidden\" name=\"action\" value=\"getid\">\n
<input type=\"submit\" value=\"Modify\"></form></td>\n
<td><form action=\"$cgi\" method=\"post\">\n
&nbsp;<input type=\"hidden\" name=\"to\" value=\"$request{'to'}\"><input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">
<input type=\"hidden\" name=\"action\" value=\"viewdata\">
<input type=\"submit\" value=\"View data\"></form></td></tr>
</table>\n
To $request{'to'} members<br>
Contact Email: @memberx[7]<br>
Web Site URL: @memberx[5]<br>\n";
if ($state==1) {
print "Actived? Yes<br><br>\n";
}
if ($state==0) {
print "Actived? No<br><br>\n";
}
if ($find>49) {
print "<br>More than 50 matches were found.<br>\n";
print "<br><br><br>";
&button;
exit;
}
}
if ($find==0) {
print "<br>No matches were found.<br>\n";
exit;
}
print "<br>End of search result(s)<br>\n";
print "$find match(es) were found.<br>\n";
print "<br><br><br>";
&button;	
exit;
}
####send email
sub send_email {
&vpassword;

$request{'subject'}=~ s/&quot;/"/ig;
$request{'message'}=~ s/&quot;/"/ig;
$request{'subject'}=~ s/&lt;/</g;
$request{'subject'}=~ s/&gt;/>/g;
$request{'message'}=~ s/&lt;/</g;
$request{'message'}=~ s/&gt;/>/g;

opendir (DIR, "$data_location") or &error("Unable to open the dir for reading");
if ($flock==1) {
flock DIR, 2; 
}
@reading=readdir(DIR);	
@members=grep(/\.dat/, @reading);
close (DIR);

$pid = fork();
$pid;
if (!pid) {
&error("fork error");
}	
if ($pid) {
print "<h2>Done</h2>\n";	
print "The message has been sent to $request{'to'} members.\n";		
print "<br><br><br>\n";
&button;
exit;
}
else {
close (STDOUT);
}

OPENING:foreach $member (@members) {
open (data, "<$data_location/$member") or next OPENING;
if ($flock==1) {
flock data, 2; 
}
@data=<data>;
close(data);
if ($request{'to'} eq "actived") {
if (@data[10]==0) {
next OPENING;
}
}	
if ($request{'to'} eq "inactived") {
if (@data[10]==1) {
next OPENING;
}
}	
open (MAIL, "|$mail_prog") or &error("Can't open the mail program!");
print MAIL "To: @data[7]";
print MAIL "From: $youremail\n";
print MAIL "Subject: $request{'subject'}\n\n";
print MAIL "$request{'message'}";
close (MAIL);
}
exit;
}
	
#button to main page
sub button {
print "<form action=\"$cgi\" method=\"post\">";
print "<input type=\"hidden\" name=\"action\" value=\"main_page\">";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">";
print "<input type=\"submit\" value=\"Back to the admin main page\">";
print "</form>";
print "<font size=\"-1\"><b>Warning: Please close your browser if you want to log off.</b><br>";
print "Copyright 1999 CGI-Factory.com</font>";
}
#####error
sub error {
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
}
 
	
	
	

